--- old/usr/src/uts/common/fs/nfs/nfs4_srv_readdir.c	2016-06-21 14:47:39.518990805 +0200
+++ new/usr/src/uts/common/fs/nfs/nfs4_srv_readdir.c	2016-06-21 14:47:39.523464447 +0200
@@ -1397,12 +1397,11 @@
 			    FATTR4_MOUNTED_ON_FILEID_MASK)) {
 
 				if (ae & FATTR4_TIME_ACCESS_MASK) {
-					u_longlong_t sec =
-					    (u_longlong_t)va.va_atime.tv_sec;
-					uint_t nsec =
-					    (uint_t)va.va_atime.tv_nsec;
-					IXDR_PUT_HYPER(ptr, sec);
-					IXDR_PUT_INT32(ptr, nsec);
+					nfstime4 atime;
+					(void) nfs4_time_vton(&va.va_atime,
+					    &atime);
+					IXDR_PUT_HYPER(ptr, atime.seconds);
+					IXDR_PUT_INT32(ptr, atime.nseconds);
 				}
 				if (ae & FATTR4_TIME_ACCESS_SET_MASK) {
 					ASSERT(0);
@@ -1420,20 +1419,18 @@
 					IXDR_PUT_INT32(ptr, nsec);
 				}
 				if (ae & FATTR4_TIME_METADATA_MASK) {
-					u_longlong_t sec =
-					    (u_longlong_t)va.va_ctime.tv_sec;
-					uint_t nsec =
-					    (uint_t)va.va_ctime.tv_nsec;
-					IXDR_PUT_HYPER(ptr, sec);
-					IXDR_PUT_INT32(ptr, nsec);
+					nfstime4 ctime;
+					(void) nfs4_time_vton(&va.va_ctime,
+					    &ctime);
+					IXDR_PUT_HYPER(ptr, ctime.seconds);
+					IXDR_PUT_INT32(ptr, ctime.nseconds);
 				}
 				if (ae & FATTR4_TIME_MODIFY_MASK) {
-					u_longlong_t sec =
-					    (u_longlong_t)va.va_mtime.tv_sec;
-					uint_t nsec =
-					    (uint_t)va.va_mtime.tv_nsec;
-					IXDR_PUT_HYPER(ptr, sec);
-					IXDR_PUT_INT32(ptr, nsec);
+					nfstime4 mtime;
+					(void) nfs4_time_vton(&va.va_mtime,
+					    &mtime);
+					IXDR_PUT_HYPER(ptr, mtime.seconds);
+					IXDR_PUT_INT32(ptr, mtime.nseconds);
 				}
 				if (ae & FATTR4_TIME_MODIFY_SET_MASK) {
 					ASSERT(0);
